//
//  SphereSampleViewController.m
//  SphereSample
//
//  Created by Ryoichi SHINBORI on 10-04-29.
//  Copyright Ryoichi SHINBORI 2010. All rights reserved.
//

#import "SphereSampleViewController.h"
#import "SphereView.h"

@implementation SphereSampleViewController

- (void)awakeFromNib {
  srandom(time(NULL));
}

- (void)loadView {
  [super loadView];

  const CGRect  rect = [[UIScreen mainScreen] bounds];
  const CGFloat cellWidth  = 40.0;
  const CGFloat cellHeight = 40.0;
  const CGFloat minRadius  = 6.0;
  
  for (int ii = 0; ii < rect.size.width/cellWidth; ii++) {
    for (int jj = 0; jj < rect.size.height/cellHeight; jj++) {
      SphereView *sphere = [[SphereView alloc] initWithFrame:CGRectMake(ii*cellWidth, jj*cellHeight, cellWidth, cellHeight)];
      sphere.red    = random()%0x100/(CGFloat)0xff;
      sphere.green  = random()%0x100/(CGFloat)0xff;
      sphere.blue   = random()%0x100/(CGFloat)0xff;
      sphere.radius = minRadius + random()%(NSInteger)(fmin(cellWidth, cellHeight)/2-minRadius);
      [self.view addSubview:sphere];
      [sphere release];
    }
  }
}

@end
