//
//  SphereView.m
//  SphereView
//
//  Created by Ryoichi SHINBORI on 10-04-29.
//  Copyright Ryoichi SHINBORI 2010. All rights reserved.
//

#import "SphereView.h"
#import <math.h>

@implementation SphereView

@synthesize red    = mRed;
@synthesize green  = mGreen;
@synthesize blue   = mBlue;
@synthesize radius = mRadius;

- (id)initWithFrame:(CGRect)frame {
  if (self = [super initWithFrame:frame]) {
    self.red = 0.0;
    self.green = 0.0;
    self.blue = 0.0;
    self.radius = 5.0;
  }
  return self;
}

- (void)drawRect:(CGRect)rect {
  //NSLog(@"%f %f %f %f", mRed, mGreen, mBlue, mRadius);
  
  CGRect  bbox = self.frame;
  CGFloat cx   = bbox.size.width/2.0;
  CGFloat cy   = bbox.size.height/2.0;
  CGFloat colors[] = {1.0, 1.0, 1.0, 1.0, self.red, self.green, self.blue, 1.0};

  CGColorSpaceRef rgb  = CGColorSpaceCreateDeviceRGB();
  CGGradientRef   grad = CGGradientCreateWithColorComponents(rgb, colors, NULL, sizeof(colors)/(sizeof(colors[0])*4));
  CGContextRef    ctx  = UIGraphicsGetCurrentContext();
  
  CGContextSaveGState(ctx);
  CGContextBeginPath(ctx);
  CGContextAddArc(ctx, cx, cy, self.radius, 0, M_PI*2, 0);
  CGContextClosePath(ctx);
  CGContextClip(ctx);
  CGContextDrawLinearGradient(ctx, grad, CGPointMake(cx, cy-self.radius), CGPointMake(cx, cy+self.radius), 0);
  CGContextRestoreGState(ctx);
  
  CGGradientRelease(grad);
  CGColorSpaceRelease(rgb);
}

@end
